#ifndef GTEST_INCLUDE_GTEST_GTEST_H_
#define GTEST_INCLUDE_GTEST_GTEST_H_
#define GTEST_INCLUDE_GTEST_INTERNAL_GTEST_INTERNAL_H_
#include "gtest/internal/gtest-port.h"
void operator<<(const testing::internal::Secret&, int);
        namespace testing {
       class GTEST_API_ Message {
       public:   Message();
        template <typename T>   inline Message& operator<<(const T& val) {
         using ::operator<<;
         *ss_ << val;
       }
       private:   const internal::scoped_ptr< ::std::stringstream> ss_;
      };
         }
        namespace testing {
                    class TestInfo;
       namespace internal {
      typedef const void* TypeId;
      template <typename T> TypeId GetTypeId() ;
      class TestFactoryBase {};
      template <class TestClass> class TestFactoryImpl : public TestFactoryBase {};
      typedef void (*SetUpTestCaseFunc)();
      typedef void (*TearDownTestCaseFunc)();
      struct CodeLocation {
       CodeLocation(const string& a_file, int a_line)  ;
     };
      GTEST_API_ TestInfo* MakeAndRegisterTestInfo(     const char* test_case_name, const char* name, const char* type_param,     const char* value_param, CodeLocation code_location,     TypeId fixture_class_id, SetUpTestCaseFunc set_up_tc,     TearDownTestCaseFunc tear_down_tc, TestFactoryBase* factory);
#define GTEST_REMOVE_REFERENCE_0 \
  GTEST_REMOVE_CONST_0
 }
         }
#define GTEST_MESSAGE_AT_(file, line, message, result_type)             \
  ::testing::internal::AssertHelper(result_type, file, line, message) = \
      ::testing::Message()
#define GTEST_MESSAGE_(message, result_type) \
  GTEST_MESSAGE_AT_(__FILE__, __LINE__, message, result_type)
#define GTEST_FATAL_FAILURE_(message) \
  return GTEST_MESSAGE_(message, ::testing::TestPartResult::kFatalFailure)
#define GTEST_TEST_CLASS_NAME_(test_case_name, test_name) \
  test_case_name##_##test_name##_Test
#define GTEST_TEST_(test_case_name, test_name, parent_class, parent_id)       \
  class GTEST_TEST_CLASS_NAME_(test_case_name, test_name)                     \
      : public parent_class {                                                 \
    virtual void TestBody();                                                  \
    static ::testing::TestInfo* const test_info_ GTEST_ATTRIBUTE_UNUSED_;     \
  };                                                                          \
  ::testing::TestInfo* const GTEST_TEST_CLASS_NAME_(test_case_name,           \
                                                    test_name)::test_info_ =  \
      ::testing::internal::MakeAndRegisterTestInfo(                           \
          #test_case_name, #test_name, NULL, NULL,                            \
          ::testing::internal::CodeLocation(__FILE__, __LINE__), 0, \
          parent_class::SetUpTestCase, parent_class::TearDownTestCase,        \
          new ::testing::internal::TestFactoryImpl<GTEST_TEST_CLASS_NAME_(    \
              test_case_name, test_name)>);                                   \
  void GTEST_TEST_CLASS_NAME_(test_case_name, test_name)::TestBody()
#include "gtest/gtest-test-part.h"
namespace testing {
       namespace internal {}
       class GTEST_API_ AssertionResult {
       public:   AssertionResult();
        operator bool() const ;
        const char* message() const ;
        const char* failure_message() const ;
        template <typename T>   AssertionResult& operator<<(const T& value) {
         AppendMessage(Message() << value);
       }
       private:   void AppendMessage(const Message& a_message) ;
      };
       GTEST_API_ AssertionResult AssertionSuccess();
       GTEST_API_ AssertionResult AssertionFailure();
       class GTEST_API_ Test {
       public:   friend class TestInfo;
        static void SetUpTestCase() ;
        static void TearDownTestCase() ;
      };
       namespace internal {
      class GTEST_API_ AssertHelper {
      public:   AssertHelper(TestPartResult::Type type, const char* file, int line,                const char* message);
       void operator=(const Message& message) const;
     };
      }
#include "gtest/gtest_pred_impl.h"
#define TEST_F(test_fixture, test_name)              \
  GTEST_TEST_(test_fixture, test_name, test_fixture, \
              ::testing::internal::GetTypeId0)
}
#endif  
namespace outer_namespace {
       namespace inner_namespace {
      template <typename Type> struct MyClass {};
      }
         }
          template <class Type>  std::ostream& operator<<(     std::ostream& os, const outer_namespace::inner_namespace::MyClass<Type>& line_segment) ;
       namespace outer_namespace {
       using FloatType = float;
       namespace inner_namespace {
      bool DoesMyClassHaveMembersInOrder(     const MyClass<FloatType>& line_segment) ;
      class MyClassTest : public ::testing::Test {
      protected:   
       MyClass<FloatType> line_segment_1_;
     };
      TEST_F(MyClassTest, ConstructorTest) {
       ASSERT_PRED1(DoesMyClassHaveMembersInOrder, line_segment_1_);
     }
      }
         }
